var MAX_NUM_FEED_DAYS = 14;
var MAX_NUM_ITEM_PER_FEED = 10;
var NUM_SEC_PER_ITEM = 6000;
var gConfUrl="http://c.icq.com/xtraz2/products/info_feed_max/content/feeds_config.js";
var gConfigObj = null;
var gTempConfigObj = null;
var gXmlDocFeedsArr = new Array();
var gIsSentStats = false;
var bIsFirstTimeUse = true;
var isUpdate = false;

function component (_gadget)
{
	this.gadget = _gadget;
	this.configTimer = null;
	this.mPrefs = null;
	this.mFeeds = new Array();
	this.mItemsOrder = 0;
	this.mFilteredSourcesIDArr = 0;
	this.numFilteredFeeds = 0;
	this.numFinishedFeeds = 0;
	this.mNumTotalSources = 0;
	this.feedTimer = new Array();
	this.currentItemInOrder;
	shell.isDialogOpened = false;
}
  
component.prototype.OnInitXtra = function(connector)
{
	this.icqConnector = connector;
	gXmlDocFeedsArr = new Array();
	this.icqConnector.AttachEvent("BeforeShutDown",OnXtraClosed);
	OnXtraClosed.owner = this;
	var loadingText = this.gadget.getPartById("loading");
	var feeds = this.gadget.getPartById("feeds");
	loadingText.setAttribute("value",this.icqConnector.GetString("info_feed_max.loading"));
	//loadingText.setStyle("fill",red);
	loadingText.setAttribute("collapsed",false);
	feeds.setAttribute("collapsed",true);
	
	this.startProccess();
}


function OnXtraClosed(reason)
{
	arguments.callee.owner.OnXtraClosed(reason);
}

component.prototype.setPrefsStats = function()
{
	var oOwner = this.icqConnector.Owner;
	var prefsLength = this.mPrefs.feedSources.length;
	
	for(index=0;index<prefsLength;index++)
	{
		if(this.mPrefs.feedSources[index].selected == 'true')
		{
			var indexInConfig = findFeedIndexInConfigArr(0, this.mPrefs.feedSources[index].id)
			oOwner.OwnerStatistic.Collection.IncrementMapSecondDItem("CUsage", "IFR", gConfigObj.RssList[indexInConfig].srp_id, "1"); 
		}
	}
}

component.prototype.OnXtraClosed = function()
{
	var scn = shell.getSceneByName("prefs");
	 if (scn)
    {
        shell.closeScene(scn);
    }

	//destroy members
	this.mFeeds = null;
	this.mItemsOrder = 0;
	this.mFilteredSourcesIDArr = 0;
	this.numFilteredFeeds = 0;
	this.numFinishedFeeds = 0;
	this.mNumTotalSources = 0;
	this.configTimer.cancel();
	(this.feedTimer.length != 0)?this.cancelFeedTimers():'';
	(this.ItemsTimer != undefined)?this.ItemsTimer.cancel():'';
	this.mPrefs = null;
	
	//destroy globals
	gXmlDocFeedsArr = null;
	gConfigObj = null;
	bIsFirstTimeUse = true;
	isUpdate = false;
	gIsSentStats = false;
}

component.prototype.cancelFeedTimers = function()
{
	var prefsLength = this.mPrefs.feedSources.length;
	
	for(index=0;index<prefsLength;index++)
	{
		if(this.mPrefs.feedSources[index].selected == 'true')
		{
			var feedID = parseInt(this.mPrefs.feedSources[index].id);
			this.feedTimer[feedID].cancel();
		}
	}
}

component.prototype.validateFeed = function(feedID)
{
	var indexInConfig = findFeedIndexInConfigArr(0, feedID);
	
	//caching solution - download a random url suffix 
	//var randInt = Math.floor(Math.random()*101)
	var feedUrl = encodeURI(gConfigObj.RssList[indexInConfig].src);
	var feedTtl = gConfigObj.RssList[indexInConfig].ttl;
	
	//timer for the next ajax call to the xml (first release previous timer)
	if (this.feedTimer[feedID])
	{
	  this.feedTimer[feedID].cancel();
	}
	
	this.feedTimer[feedID] = setTimeoutObjectEx(this,"validateFeed",feedTtl, feedID);
	
	if (gXmlDocFeedsArr[feedID])
	{
	  gXmlDocFeedsArr[feedID] = null;  
	}
	
	gXmlDocFeedsArr[feedID] = this.xmlHttp();

	if(gXmlDocFeedsArr[feedID]) 
	{
		validateFeedCallBkGlobal.owner = this;
		gXmlDocFeedsArr[feedID].onreadystatechange = function(){validateFeedCallBkGlobal(feedID)};
		gXmlDocFeedsArr[feedID].open("GET", feedUrl, true);
		gXmlDocFeedsArr[feedID].send("");
	}
}

function parseDate(dateStr)
{
	var feedUnixDate;
	var timezone = dateStr.split(" ")[5];
	
	switch(timezone)
	{
	
		case 'CET':
					var datePrefStr = dateStr.substr(0, dateStr.length-4);
					datePrefStr += ' GMT';
					feedUnixDate = Date.parse(datePrefStr);
					feedUnixDate += 3600;
					break;
		case 'GMT':
		default:
					feedUnixDate = Date.parse(dateStr);
					break;
	}
	
	
	return feedUnixDate;
}

function validateFeedCallBkGlobal(feedID)
{
	arguments.callee.owner.validateFeedCallBk(feedID);
}

component.prototype.validateFeedCallBk = function(feedID)
{
	if (gXmlDocFeedsArr[feedID].readyState == 4)
	{
		if (gXmlDocFeedsArr[feedID].status == 200)
		{
			//get feed date and compare with today
			var feedDate = gXmlDocFeedsArr[feedID].responseXML.getElementsByTagName("lastBuildDate")[0].text;
			var feedUnixDate = parseDate(feedDate);
			var dateMargin = dateDiff(feedUnixDate);
			
			//check if feed is already in xtra's displayed feeds
			var bIsinFeedList = this.searchFeedInCurrentFeeds(feedID);
			
			if(bIsinFeedList!=-1)
			{	
				//if in current displayed feeds, check if is newer than the one already in
				if(this.mFeeds[bIsinFeedList].updated < feedUnixDate)
				{
					this.mFeeds[bIsinFeedList] = null;
					this.getItems(feedID, feedUnixDate, true, bIsinFeedList);
					isUpdate = true;
				}
			}
			//check if feed older than X days OR is with the same timestamp as current one
			else if(dateMargin < MAX_NUM_FEED_DAYS && dateMargin!=0)
			{	
				this.getItems(feedID, feedUnixDate, false, bIsinFeedList);
				
				//in case an invalid feed was updated - this is not a first time use and therefore the ui shouldnt wait for
				//other ajax call
				isUpdate = (bIsFirstTimeUse)?false:true;
				
			}
			
			this.numFinishedFeeds++;
		}
		else{}

		numUserSelectedFeeds = this.getNumSelectedFeeds();
		if((this.numFinishedFeeds == numUserSelectedFeeds && bIsFirstTimeUse) || isUpdate)
		{	
			if(!gIsSentStats)
			{
				this.setPrefsStats();
				gIsSentStats = true;
			}
			
			this.presentXtra();
			isUpdate = false;
			this.numFinishedFeeds = 0;
		}
	}
}

//get current number of enabled feeds by the user (from prefs array)
component.prototype.getNumSelectedFeeds = function()
{
	var arrayLength = this.mPrefs.feedSources.length;
	var selected = 0;
	
	for(i=0;i<arrayLength;i++)
	{
		if(this.mPrefs.feedSources[i].selected == 'true')
		{
			selected++;
		}
	}
	return selected;
}

component.prototype.getItems = function(feedIndex, feedDate, isUpdate, indexInFeeds)
{
	var feedArr = new Array();
	feedArr.id = feedIndex;
	feedArr.updated = feedDate;
	
	var indexInConfig = findFeedIndexInConfigArr(0, feedIndex);
	feedArr.srpID = gConfigObj.RssList[indexInConfig].srp_id;
	feedArr.logo = gConfigObj.RssList[indexInConfig].logo;
	
	var mainPageType = gXmlDocFeedsArr[feedIndex].responseXML.getElementsByTagName("category")[0].text;
	
	feedArr.mainPageType = mainPageType;
	feedArr.mainPage = gXmlDocFeedsArr[feedIndex].responseXML.getElementsByTagName("link")[0].text;
	feedArr.iconTooltip = gXmlDocFeedsArr[feedIndex].responseXML.getElementsByTagName("title")[0].text;
	
	var items = gXmlDocFeedsArr[feedIndex].responseXML.getElementsByTagName("item");
	var numItems = items.length;
	var itemArr = new Array();
	var numFeedsItem = 0;
	
	for(var i=0;i<items.length && numFeedsItem < numItems;i++)
	{
		var date = items[i].getElementsByTagName("lastBuildDate")[0].text;
		var dateTS = parseDate(date);
		var itemDateMargin = dateDiff(dateTS);
		
		//check item's date and parse
		if(itemDateMargin < MAX_NUM_FEED_DAYS)
		{
			var item = new Array();
			item.type = items[i].getElementsByTagName("category")[0].text;
			
			if(item.type == 'web')
			{
				item.link = items[i].getElementsByTagName("link")[0].text;
			}
			else if(item.type == 'xtra')
			{
				item.xtraID = items[i].getElementsByTagName("xtraID")[0].text;
				try{item.initData = items[i].getElementsByTagName("initData")[0].text;}catch(e){item.initData="0"}
			}
			
			item.date = dateTS;
			
			try{item.description = items[i].getElementsByTagName("description")[0].text;}catch(e){item.description="0"}
			try{item.enclosure = items[i].getElementsByTagName("enclosure")[0].getAttribute("url");}catch(e){item.enclosure="0"}
			try{item.title = items[i].getElementsByTagName("title")[0].text;}catch(e){item.title=""}
			
			numFeedsItem++;
			itemArr.push(item);
		}
	}		
	
	//filter empty xml or old items
	
	var itemArrLength = itemArr.length;
	if(itemArrLength != 0)
	{
		itemArr.sort(sortDates);
		
		//in case more than required items were chosen
		var finalItemsArr = new Array();
		finalItemsArr = (itemArrLength > MAX_NUM_ITEM_PER_FEED)?itemArr.slice(0, MAX_NUM_ITEM_PER_FEED):itemArr.slice();
		feedArr.items = finalItemsArr;
		
		if(isUpdate)
		{
			this.mFeeds[indexInFeeds] = feedArr;
		}
		else
		{
			this.mFeeds.push(feedArr);
		}
	}
}

//searches the current feeds presented in xtra using the feed id of the current one in loop
component.prototype.searchFeedInCurrentFeeds = function(feedID)
{
	var arrayLength = this.mFeeds.length;
	
	for(i=0;i<arrayLength;i++)
	{
		if(this.mFeeds[i]!=null && this.mFeeds[i].id==feedID)
		{
			return i;
		}
	}
	return -1;
}

component.prototype.isAnyFeedSelected = function()
{
	var index = 0;
	var bFoundFeed = false;
	
	while(!bFoundFeed && index<this.numFilteredFeeds)
	{
		if(this.mPrefs.feedSources[index].selected=="true")
		{
			bFoundFeed = true;
		}
		index++;
	}
	return bFoundFeed;
}

component.prototype.isAnyItem = function()
{
	var index = 0;
	var bFoundItem = false;
	
	while(!bFoundItem && index<this.mFeeds.length)
	{
		if(this.mFeeds[index]!=null && this.mFeeds[index].items.length!=0)
		{
			bFoundItem = true;
		}
		index++;
	}
	return bFoundItem;
}

component.prototype.setPrefs = function()
{
	var prefString = this.icqConnector.GetPrefsValues(false);
	var bPrefsExist = (prefString!="")?true:false;
	var prefFeedArr = false;
	
	//pref file exist
	if(bPrefsExist)
	{	
		//case of first time use
		if(this.mPrefs == null)
		{
			this.mPrefs = new Object();
			eval("this.mPrefs = " + prefString);
		}
		
		prefString = '{"feedSources":[';
		
		//if prefs exists compare the filtered id's with prefs feeds.
		//if a feed was added - add,if removed-ignore,if existed get the pref
		//go over selected feeds from all filtered sources and change accordingly.
		for(i=0;i<this.numFilteredFeeds;i++)
		{ 
			prefFeedArr = this.inPrefsArr(this.mFilteredSourcesIDArr[i]);
			if(prefFeedArr["found"])
			{
				gConfigObj.RssList[i].selected = '"'+prefFeedArr["pref"]+'"';
				prefString += '{"id":"'+this.mFilteredSourcesIDArr[i]+'","selected":"'+prefFeedArr["pref"]+'"},';
			}
			else
			{
				var indexInConfigArr = findFeedIndexInConfigArr(0, this.mFilteredSourcesIDArr[i]);
				gConfigObj.RssList[indexInConfigArr].selected = "true";
				prefString += '{"id":"'+this.mFilteredSourcesIDArr[i]+'","selected":"true"},';
			}
		}
		prefString = prefString.substr(0,prefString.length-1);
		prefString += ']}';
	}
	else
	{
		//get all filtered feeds and assign them with default "true"
		prefString = '{"feedSources":[';
		
		for(i=0;i<this.numFilteredFeeds;i++)
		{ 
			gConfigObj.RssList[i].selected = "true";
			prefString += '{"id":"'+this.mFilteredSourcesIDArr[i]+'","selected":"true"},';
		}
		prefString = prefString.substr(0,prefString.length-1);
		prefString += ']}';
	}
	
	//create pref file and assign to a member var
	eval("this.mPrefs = " + prefString);
	this.icqConnector.SetPrefsValues(false, prefString);
}

function findFeedIndexInConfigArr(configType, feedID)
{
	var index = 0;
	var configLength = (configType!=0)?gTempConfigObj.RssList.length:gConfigObj.RssList.length;
	
	while(index<configLength)
	{
		if(configType!=0)
		{
			if(gTempConfigObj.RssList[index].id == feedID)
			{
				return index;
			}
		}
		else
		{
			if(gConfigObj.RssList[index].id == feedID)
			{
				return index;
			}
		}
		
		index++;
	}
	return -1;
}

component.prototype.findFeedIndexInMfeed = function(feedID) 
{
	var mFeedsLength = this.mFeeds.length
	var index = 0;
	
	while(index<mFeedsLength)
	{
		if(this.mFeeds[index]!=null && this.mFeeds[index].id == feedID)
		{
			return index;
		}
		index++;
	}
	return -1;
}

component.prototype.findFeedIndexInMPrefs = function(feedID) 
{
	var mPrefsLength = this.mPrefs.feedSources.length
	var index = 0;
	
	while(index<mPrefsLength)
	{
		if(this.mPrefs.feedSources[index].id == feedID)
		{
			return index;
		}
		index++;
	}
	return -1;
}

component.prototype.inPrefsArr = function(feedID) 
{
	var i = 0;
	var returnArr = new Array;
	returnArr["found"] = false;
	
    while(i<this.mPrefs.feedSources.length) 
	{
		if(this.mPrefs.feedSources[i].id == feedID)
		{
			returnArr["found"] = true;
			returnArr["pref"]  = this.mPrefs.feedSources[i].selected;
			return returnArr;
		}
		i++;
    }
    return returnArr;
}

component.prototype.getSourcesList = function()
{
	this.mNumTotalSources = getNumTotalFeeds();
	var index;
	var countryList;
	var bIncCountry = false; var bExcCountry = false; var bCountry = false;
	var bExcLSP = false; var bIncLSP = false; var bLSP = false;

	var countryID = this.icqConnector.GetGeoTargetClientCountryCode();
	var LSPID = this.icqConnector.GetIMClientData("LSP_ID");
	
	this.mFilteredSourcesIDArr = null;
	this.mFilteredSourcesIDArr = new Array();
	//go over feeds list and filter using LSP + Geo data
	for(index=0;index<this.mNumTotalSources;index++)
	{
		bInCountry = (inArray(countryID, gConfigObj.RssList[index].includedCountry) || inArray("9999", gConfigObj.RssList[index].includedCountry))?true:false;
		bExcCountry = (inArray(countryID, gConfigObj.RssList[index].excludedCountry))?true:false;
		bIncLSP = (inArray(LSPID, gConfigObj.RssList[index].includedLSP) && inArray("undefined", gConfigObj.RssList[index].includedCountry))?false:true;
		bExcLSP = (inArray(LSPID, gConfigObj.RssList[index].excludedLSP))?true:false;

		bCountry = (bInCountry && !bExcCountry)?true:false;
		bLSP = (bIncLSP && !bExcLSP)?true:false;

		if(bCountry && bLSP)
		{
			
			this.mFilteredSourcesIDArr.push(gConfigObj.RssList[index].id);
		}
	}
	
	this.numFilteredFeeds = this.mFilteredSourcesIDArr.length;
}

component.prototype.xmlHttp = function(){
	try {
		var xmlDoc = new ActiveXObject("Msxml2.XMLHTTP");
	} catch(e) {
		try {
			var xmlDoc = new ActiveXObject("Microsoft.XMLHTTP");
		} catch(e) {
			var xmlDoc = false;
		}
	}
	return xmlDoc;
}

component.prototype.startProccess = function()
{
	gXmlDocFeedsArr['config'] = this.xmlHttp();
	
	if(gXmlDocFeedsArr['config']) 
	{
		startProccessCallBkGlobal.owner = this;
		gXmlDocFeedsArr['config'].onreadystatechange = startProccessCallBkGlobal;
		gXmlDocFeedsArr['config'].open("GET", gConfUrl, true);
		gXmlDocFeedsArr['config'].send("");
	}
}

function startProccessCallBkGlobal()
{
	arguments.callee.owner.startProccessCallBk();
}

//get the recent config file from server
component.prototype.startProccessCallBk = function()
{
	if (gXmlDocFeedsArr['config'].readyState == 4)
	{
		if (gXmlDocFeedsArr['config'].status == 200)
		{
			eval("gTempConfigObj =" + gXmlDocFeedsArr['config'].responseText);
			var compareArr = compareConfigFiles();
			
			//if the config file has changed
			if(!compareArr["isEqual"])
			{	
				//if sources were removed from  config, update members and flag with the global vars to re-present xtra
				//remove from current active timers and update main data structure (mFeeds)
				if(compareArr["removedFeeds"].length>0)
				{
					this.changeCurrentFeedsArr(compareArr);
					this.abortFeedTimer(compareArr);
					this.ItemsTimer.cancel();
					
					bIsFirstTimeUse = true;
					this.numFinishedFeeds = 0;
				}
	
				gConfigObj = gTempConfigObj;
				gTempConfigObj = null;
				gXmlDocFeedsArr['config'] = null;
	
				this.getSourcesList();
				this.setPrefs();
				this.proccessFeeds();
			}
			
			this.configTimer = setTimeoutObject(this,"startProccess", gConfigObj.timeOut);
		}
	}
}

component.prototype.changeCurrentFeedsArr = function(compareArr)
{
	var tempMFeeds = new Array();
	var mFeedsLength = this.mFeeds.length;
	var answer = false;
	
	for(index=0;index<mFeedsLength;index++)
	{
		answer = inArray(this.mFeeds[index].id ,compareArr);
		if(!answer)
		{
			tempMFeeds.push(this.mFeeds[index]);
		}
	}
	
	this.mFeeds = tempMFeeds;
}

component.prototype.proccessFeeds = function()
{
	var bIsValidated = false;
	var bIsAnySelected = false;
		
	for(index=0;index<this.numFilteredFeeds;index++)
	{
		if(this.mPrefs.feedSources[index].selected=="true")
		{
			this.validateFeed(this.mPrefs.feedSources[index].id);
			bIsAnySelected = true;
		}
	}
	
	if(!bIsAnySelected)
	{
		var mainWindow = this.gadget.getPartById("mainWindow");
		var mainDate = this.gadget.getPartById("feedData");
		var mainImg = this.gadget.getPartById("feedImg");
		var noFeeds = this.gadget.getPartById("noFeeds");
		var mainFeeds = this.gadget.getPartById("feeds");
		var loadingText = this.gadget.getPartById("loadingText");
		var loading = this.gadget.getPartById("loading");
		
		loading.setAttribute("collapsed",true);
		mainWindow.setAttribute("collapsed",true);
		mainDate.setAttribute("collapsed",true);
		mainImg.setAttribute("collapsed",true);
		mainFeeds.setAttribute("collapsed",true);
		noFeeds.setAttribute("collapsed",false);
		loadingText.setAttribute("label",this.icqConnector.GetString("info_feed_max.noFeedsChosen"));
		loadingText.setAttribute("collapsed",false);
	}
	
}

//comparison between 2 config files - current one and the new one that was read
function compareConfigFiles()
{
	var feedIDArr = new Array();
	feedIDArr["isEqual"] = true;
	feedIDArr["removedFeeds"] = new Array();
	
	if(gConfigObj != null)
	{
		var configFeedsLength = gConfigObj.RssList.length;
		var tempConfigFeedsLength = gTempConfigObj.RssList.length;
		
		//find feeds that have been removed from current user's feeds - use this info to cancel timers for them
		i=0;
		var bIsTemoveFeed = false;
		var removeFeedIDArr = new Array();
		
		while(i<configFeedsLength)
		{
			var isInNewConfig = findFeedIndexInConfigArr(1, gConfigObj.RssList[i].id);
			
			if(isInNewConfig==-1)
			{
				removeFeedIDArr.push(gConfigObj.RssList[i].id);
				bIsTemoveFeed = true;
			}
			i++;
		}
		feedIDArr["removedFeeds"] = removeFeedIDArr;
		feedIDArr["isEqual"] = bIsNewFeed;
		
		//find at least on feed that does'nt exist in user's current feed list
		i=0;
		var bIsNewFeed = false;
		
		while(i<tempConfigFeedsLength && !bIsNewFeed)
		{
			var isInOldConfig = findFeedIndexInConfigArr(0, gTempConfigObj.RssList[i].id);
			
			if(isInOldConfig==-1)
			{
				bIsNewFeed = true;
			}
			i++;
		}
		
		feedIDArr["isEqual"] = (bIsNewFeed)?false:true;
	}
	else
	{
		feedIDArr["isEqual"] = false;
	}
	
	return feedIDArr;
}

//if new config file without "feedIDArr" feeds ID's, cancel the existing timers for each value in argument
component.prototype.abortFeedTimer = function(feedIDArr)
{
	var arrayLength = feedIDArr["removedFeeds"].length;
	
	for(i=0;i<arrayLength;i++)
	{
		this.feedTimer[feedIDArr["removedFeeds"][i]].cancel();
		this.feedTimer[feedIDArr["removedFeeds"][i]] = null;
	}
}

function inArray(needle, haystack, argStrict) 
{
    var found = false, key, strict = !!argStrict;
 
    for(key in haystack) 
	{
        if((strict && haystack[key] === needle) || (!strict && haystack[key] == needle)) 
		{
            found = true;
            break;
        }
    }
	
    return found;
}

component.prototype.createDisplayOrder = function()
{
	var numTotalItems = 0;
	var tempFeedIDArr = this.mFilteredSourcesIDArr.slice();
	
	tempFeedIDArr.sort(randOrd);
	
	//calc number total number of available items
	for(i=0;i<this.mFeeds.length && this.mFeeds.length!=0;i++)
	{
		if(this.mFeeds[i] != null)
		{
			numTotalItems += this.mFeeds[i].items.length;
		}
	}
	
	//go over number of picks and choose accroding to tempFeedIDArr order
	var currentNumItems=0;
	var currentFeedIndex=0;
	var currentItemIndex=0;
	
	while(currentItemIndex<MAX_NUM_ITEM_PER_FEED && currentNumItems<numTotalItems)
	{
		while(currentFeedIndex<tempFeedIDArr.length && currentNumItems<numTotalItems)
		{
			var mFeedIndex = this.findFeedIndexInMfeed(tempFeedIDArr[currentFeedIndex]);
			if(this.mFeeds[mFeedIndex]!=null && this.mFeeds[mFeedIndex]["items"][currentItemIndex]!=undefined)
			{
				var tempItemArr = new Array();
				tempItemArr["feedID"] = tempFeedIDArr[currentFeedIndex];
				tempItemArr["itemIndex"] = currentItemIndex;
				
				this.mItemsOrder.push(tempItemArr);
				currentFeedIndex++;
				currentNumItems++;
			}
			else
			{
				currentFeedIndex++;
			}
		}
		currentFeedIndex=0;
		currentItemIndex++;	
	}
}


component.prototype.openLink = function()
{
	var item = this.gadget.getPartById("mainWindow");
	var itemType = item.getAttribute("type");
	var srpID = this.gadget.getPartById("mainWindow").getAttribute("srpID");
	
	if(itemType == 'web')
	{
		this.icqConnector.OpenUrl(item.getAttribute("link"));
	}
	else if (itemType == 'xtra')
	{
		this.icqConnector.OpenPlugin(this.icqConnector.GetIMOwnerData("SCREEN_NAME"),item.getAttribute("xtraID"),item.getAttribute("initData"));
	}
	
	//statistics
	var oOwner = this.icqConnector.Owner;
	oOwner.OwnerStatistic.Collection.IncrementMapSecondDItem("CUsage", "IF", srpID, srpID); 
}
//-------------------------- UI START------------------------------------------------------------------------------------------------- //

component.prototype.presentXtra = function()
{
	//check prefs for at least 1 feed selection
	var bIsSelectedFeed = this.isAnyFeedSelected();
	var bDisplayXtra = this.isAnyItem();
	var mainWindow = this.gadget.getPartById("mainWindow");
	var mainDate = this.gadget.getPartById("feedData");
	var mainImg = this.gadget.getPartById("feedImg");
	
	var mainFeed = this.gadget.getPartById("feeds");
	var loadingText = this.gadget.getPartById("loadingText");
	loadingText.setAttribute("label",this.icqConnector.GetString("info_feed_max.loading"));
	var noFeeds = this.gadget.getPartById("noFeeds");
	var loading = this.gadget.getPartById("loading")
	
	if(bIsSelectedFeed && bDisplayXtra)
	{
		if(!bIsFirstTimeUse)
		{
			if(this.ItemsTimer)
			{
				this.ItemsTimer.cancel();
			}
		}
			
		this.mItemsOrder = null;
		this.mItemsOrder = new Array();
		
		this.createDisplayOrder();
		
		var mainWindow = this.gadget.getPartById("mainWindow");
		
		loading.setAttribute("collapsed",true);
		noFeeds.setAttribute("collapsed",true);
		mainWindow.setAttribute("collapsed",false);
		mainDate.setAttribute("collapsed",false);
		mainImg.setAttribute("collapsed",false);
		mainFeed.setAttribute("collapsed",false);
	
		this.currentItemInOrder = -1;
		this.iterateItems();
	}
	else
	{
		loading.setAttribute("collapsed",true);
		mainWindow.setAttribute("collapsed",true);
		mainDate.setAttribute("collapsed",true);
		mainImg.setAttribute("collapsed",true);
		mainFeed.setAttribute("collapsed",true);
		noFeeds.setAttribute("collapsed",false);	
		loadingText.setAttribute("collapsed",false);
		
		if(!bIsSelectedFeed)loadingText.setAttribute("label",this.icqConnector.GetString("info_feed_max.noFeedsChosen"));
		else if(!bDisplayXtra)loadingText.setAttribute("label",this.icqConnector.GetString("info_feed_max.noFeeds"));
	}
	
	bIsFirstTimeUse = false;
}

component.prototype.isLastItem = function()
{
	var orderLength = this.mItemsOrder.length;
	(this.currentItemInOrder == orderLength-1)?this.currentItemInOrder=0:this.currentItemInOrder++;
}

component.prototype.isFirstItem = function()
{
	var orderLength = this.mItemsOrder.length;
	(this.currentItemInOrder == 0)?this.currentItemInOrder=orderLength-1:this.currentItemInOrder--;
}

component.prototype.iterateItems = function()
{
	this.ItemsTimer = setTimeoutObject(this,"iterateItems",NUM_SEC_PER_ITEM);
	this.isLastItem();
	this.showItem(this.currentItemInOrder);
}

component.prototype.pageItems = function(direction)
{
	(direction=="next")?this.isLastItem():this.isFirstItem();
	this.showItem(this.currentItemInOrder);
}

component.prototype.isCursorInGadget = function()
{
	var gadgetX = this.gadget.screenX;
	var gadgetY = this.gadget.screenY;
	var gadgetWidth = this.gadget.boxWidth;
	var gadgetHeight = this.gadget.boxHeight;
	
	var eventObj = shell.currentEvent;
	var eventXCursor = eventObj.screenX;
	var eventYCursor = eventObj.screenY;
	
	var isXIn = eventXCursor >= gadgetX  && eventXCursor <= (gadgetX + gadgetWidth);
	var isYIn = eventYCursor >= gadgetY && eventYCursor <= (gadgetY + gadgetHeight);
	
	if(isXIn && isYIn)
	{
		return true;
	}
	else
	{
		return false;
	}
}

component.prototype.stopRotation = function()
{
	if(this.ItemsTimer)
	{
		this.ItemsTimer.cancel();
	}
}

component.prototype.startRotation = function()
{
	var bIsIn = this.isCursorInGadget();
	
	if(!bIsIn)
	{
		this.ItemsTimer = setTimeoutObject(this,"iterateItems",NUM_SEC_PER_ITEM);
	}
}


component.prototype.updateNavBar = function()
{
	var navBar = this.gadget.getPartById("navBar");
	var navBarStr = "<b>"+(this.currentItemInOrder+1)+"</b>/"+this.mItemsOrder.length;
	
	navBar.setAttribute("value",navBarStr);
}

component.prototype.showItem = function()
{
	//get current item shown from order array
	var itemFeed = this.mItemsOrder[this.currentItemInOrder].feedID;
	var itemIndex = this.mItemsOrder[this.currentItemInOrder].itemIndex;

	//search for the feed index in feeds array
	var indexFeedList = this.searchFeedInCurrentFeeds(itemFeed);
	var currentItem = this.mFeeds[indexFeedList].items[itemIndex];
	
	var itemType = currentItem.type;
	
	var itemMain = this.gadget.getPartById("mainWindow");
	itemMain.setAttribute("type",currentItem.type);
	itemMain.setAttribute("srpID",this.mFeeds[indexFeedList].srpID);
	
	if(currentItem.type == 'web')
	{
		itemMain.setAttribute("link",currentItem.link);
	}
	else if(currentItem.type == 'xtra')
	{
		itemMain.setAttribute("xtraID",currentItem.xtraID);
		itemMain.setAttribute("initData",currentItem.initData);
	}
	
	var itemTitle = this.gadget.getPartById("feedTitle");
	itemTitle.setAttribute("label",currentItem.title);

	var itemImage = this.gadget.getPartById("feedImg");
	if(currentItem.enclosure != "0")
	{
		itemImage.setAttribute("collapsed",false);
		itemImage.setAttribute("icon",currentItem.enclosure);
	}
	else
	{
		itemImage.setAttribute("collapsed",true);
	}
	
	var itemText = this.gadget.getPartById("feedText");
	var aText = (currentItem.description != "0")?currentItem.description:'';
	itemText.setAttribute("label",aText);

	var feedIcon = this.gadget.getPartById("feedIcon");
	feedIcon.setAttribute("mainPageType",this.mFeeds[indexFeedList].mainPageType);
	feedIcon.setAttribute("icon",this.mFeeds[indexFeedList].logo);
	feedIcon.setAttribute("mainPage",this.mFeeds[indexFeedList].mainPage);
	feedIcon.setAttribute("tooltip",this.mFeeds[indexFeedList].iconTooltip);
	
	var itemDate = this.gadget.getPartById("date");
	var itemHour = this.gadget.getPartById("hour");
	
	var itemDateObj = new Date(currentItem.date);
	var formatDate = this.formatItemDate(itemDateObj);
	
	itemDate.setAttribute("value",formatDate["date"]);
	itemHour.setAttribute("value",formatDate["hour"]);

	this.updateNavBar();
}

component.prototype.openSourceMainPage = function()
{
	var feedIcon = this.gadget.getPartById("feedIcon");
	var mainPageType = feedIcon.getAttribute("mainPageType");
	
	if(mainPageType == 'web')
	{
		this.icqConnector.OpenUrl(feedIcon.getAttribute("mainPage"));
	}
	else if (mainPageType == 'xtra')
	{
		this.icqConnector.OpenPlugin(this.icqConnector.GetIMOwnerData("SCREEN_NAME"),feedIcon.getAttribute("mainPage"),"");
	}
}


component.prototype.formatItemDate = function(DateObj)
{
	var hours = DateObj.getHours()
	var minutes = DateObj.getMinutes()
	var dayNight;
	var returnArr = new Array();
	
	if (minutes < 10)
	{
		minutes = "0" + minutes;
	}
	
	if(hours > 11)
	{
		dayNight = "pm";
	} 
	else 
	{
		dayNight = "am";
	}

	returnArr["date"] = (this.icqConnector.GetIMClientData("LANG_ID")!="he-il")?this.icqConnector.GetString("info_feed_max.month"+DateObj.getMonth())+" "+DateObj.getDate()+" "+DateObj.getFullYear()+", ":
																				DateObj.getDate()+" "+this.icqConnector.GetString("info_feed_max.month"+DateObj.getMonth())+", "+DateObj.getFullYear()+" ";
	returnArr["hour"] = hours+":"+minutes;//sharon
	
	return returnArr;
}

//-------------------------- UI END------------------------------------------------------------------------------------------------- //

//-------------------------- Dialog START------------------------------------------------------------------------------------------------- //
component.prototype.setUserPrefs = function()
{
	if(!shell.isDialogOpened)
	{
		var params = this.buildParams();

		var boxFile = "box://xtraz/icq/content/info_feed_max/infoWin.box";
		var scn = shell.openScene(boxFile, null, "prefs", null, null, false);
		scn = null;
		
		//statistics
		var oOwner = this.icqConnector.Owner;
		oOwner.OwnerStatistic.Collection.IncrementItem("CUsage", "IFI");
	}
	
	shell.isDialogOpened = true;
}

component.prototype.buildParams = function()
{
	shell.prefsArr = new Array();
	var prefLength = this.mFilteredSourcesIDArr.length;
	
	for(index=0;index<prefLength;index++)
	{
		shell.prefsArr[index] = new Array();
		var feedIndex = findFeedIndexInConfigArr(0, this.mFilteredSourcesIDArr[index]);
		
		shell.prefsArr[index].id = this.mFilteredSourcesIDArr[index];
		shell.prefsArr[index].title= gConfigObj.RssList[feedIndex].title;
		shell.prefsArr[index].description = gConfigObj.RssList[feedIndex].description;
		shell.prefsArr[index].logo = gConfigObj.RssList[feedIndex].logo;
		
		var indexInPrefsArr = this.findFeedIndexInMPrefs(this.mFilteredSourcesIDArr[index]);
		shell.prefsArr[index].selected = this.mPrefs.feedSources[indexInPrefsArr].selected;
	}
}

//on return message from prefs dialog box change live prefs array and set new prefs
component.prototype.onMessage = function()
{
	var prefsLength = this.mPrefs.feedSources.length;
	var isShowUI = false;
	var isNeedValidate = false;
	this.ItemsTimer.cancel(); 
	var isPrefsNeedChange = false;
	var numValidated = 0;
	
	for(index=0;index<prefsLength;index++)
	{
		if(this.mPrefs.feedSources[index].selected != shell.prefsArr[index].selected)
		{
			this.mPrefs.feedSources[index].selected = shell.prefsArr[index].selected;
			
			if(this.mPrefs.feedSources[index].selected == 'true')	
			{
				this.validateFeed(this.mPrefs.feedSources[index].id);
				
				isNeedValidate = true;
				numValidated++;
				
			}
			else
			{
				var indexInMFeeds = this.findFeedIndexInMfeed(this.mPrefs.feedSources[index].id);
				this.mFeeds[indexInMFeeds] = null;
				this.feedTimer[this.mPrefs.feedSources[index].id].cancel();
				this.feedTimer[this.mPrefs.feedSources[index].id] = null;
				isShowUI = true;
			}
			isPrefsNeedChange = true;
		}
	}
	
	if(isPrefsNeedChange)
	{
		this.setPrefs();
	}
	
	if(isNeedValidate)
	{
		var numUserSelectedFeeds = this.getNumSelectedFeeds();
		this.numFinishedFeeds = numUserSelectedFeeds - numValidated;
		bIsFirstTimeUse  = true;
	}
	
	if(isShowUI)
	{
		this.presentXtra();
	}
	
	shell.prefsArr = null;
}


//-------------------------- Dialog END------------------------------------------------------------------------------------------------- //

function getNumTotalFeeds()
{
	var objSize = 0;
	var bStop = false;
	
	while(!bStop)
	{									
		if(typeof(gConfigObj.RssList[objSize])=='object')
		{
			objSize++;
		}
		else
		{
			bStop = true;
		}
	}
	return objSize;
}

function dateDiff(aDate)
{
	var today = new Date();
	var now = Date.parse(today);
	var dateDiff = (now-aDate)/86400000;
	
	return dateDiff;
}

function sortDates(a,b)
{
	return b.date - a.date;
}

function randOrd()
{
	return (Math.round(Math.random())-0.5); 
}