// --------------------------- component -----------------------------------
function component (_gadget)
{
	this.gadget = _gadget;
	this.icqConnector = this.gadget.parent.icqConnector ;
}
component.prototype.OnPresented = function()
{
	var game_obj = this.icqConnector.GetXtraInfoList("mini_center");
	var games_num = game_obj.count;
	for(var i = 0;i<games_num;i++)
	{
		var id = game_obj(i).Id;
		var name = game_obj(i).Name;
		var image ="box://Xtraz/icq/theme/mini_game_center/"+id+".png";
		var source = "xtra";
		var box_child = this.scene.createBox("", "icqxtraBtn");
		box_child.setAttribute("xtra_id",id, "");
		box_child.setAttribute("icon",image, "");
		box_child.setAttribute("name",name, "");
		box_child.setAttribute("type",source, "");
		var status = this.icqConnector.UserInfo.Status;
		if (status ==-1)
		{
			this.gadget.disabled="true";
		}
		
		this.gadget.addContentChild(box_child);
	}
	var lang = this.icqConnector.GetIMClientData("LANG_ID").substr(0,2);
	var id = "http://icq.miniclip.com/games/"+lang+"/";
	var name = this.icqConnector.GetString("mini_game_center.fun");
	var image ="box://Xtraz/icq/theme/mini_game_center/fun.png";
	var source = "web";
	var name_tooltip = this.icqConnector.GetString("mini_game_center.funTooltip");
	var box_child = this.scene.createBox("", "icqxtraBtn");
	box_child.setAttribute("xtra_id",id, "");
	box_child.setAttribute("icon",image, "");
	box_child.setAttribute("name",name, "");
	box_child.setAttribute("type",source, "");
	box_child.setAttribute("name_tooltip",name_tooltip, "");
	this.gadget.addContentChild(box_child);

	var id = "http://partner.bigpoint.net/icq/?locale="+lang;
	var name = this.icqConnector.GetString("mini_game_center.action");
	var image ="box://Xtraz/icq/theme/mini_game_center/actrion.png";
	var source = "web";
	var name_tooltip = this.icqConnector.GetString("mini_game_center.actionTooltip");
	var box_child = this.scene.createBox("", "icqxtraBtn");
	box_child.setAttribute("xtra_id",id, "");
	box_child.setAttribute("icon",image, "");
	box_child.setAttribute("name",name, "");
	box_child.setAttribute("type",source, "");
	box_child.setAttribute("name_tooltip",name_tooltip, "");
	this.gadget.addContentChild(box_child);
}

component.prototype.onclick = function()
{	
	var games_box= shell.currentEvent.targetBox;
	var icon_destination = games_box.getAttribute("type");
	if(icon_destination ==="web")
	{	
		var url = games_box.getAttribute("tag");;
		this.icqConnector.OpenUrl(url);
	}
	else
	{
		var status = this.icqConnector.UserInfo.Status;
		if (status !=-1)
		{
			var game_id = games_box.getAttribute("tag");
			var uin = this.icqConnector.UserInfo.ScreenName;
			this.icqConnector.SendXtra(uin, game_id, "");
		}
	}
}
