/***************************************************************************

 File Name:   aolHintInput.js

****************************************************************************
C O P Y R I G H T   A N D   C O N F I D E N T I A L I T Y   N O T I C E
****************************************************************************

  Copyright (c) 2008 AOL, LLC.  All rights reserved.
  This software contains valuable confidential and proprietary
  information of AOL, LLC. and is subject to applicable licensing
  agreements.  Unauthorized reproduction, transmission or
  distribution of this file and its contents is a violation of
  applicable laws.

                      A O L    C O N F I D E N T I A L

***************************************************************************/

function component (_gadget)
{
    this.g_noFocusText = "";
    this.g_noFocusTextVisible = true;
    this.g_inputField = _gadget.getPartById("inputField");
}
component.prototype.showUnFocusedText = function()
{
    var unfocusedDisplay = this._gadget.getPartById("unfocusedTextDisplay");
    this.g_noFocusTextVisible = true;
    unfocusedDisplay.collapsed=false;
}
component.prototype.removeUnFocusedText = function()
{
    var unfocusedDisplay = this._gadget.getPartById("unfocusedTextDisplay");
    this.g_noFocusTextVisible = false;
    unfocusedDisplay.collapsed=true;
}
component.prototype.inputBlurred = function()
{
    if(this.g_inputField.value == "")
    {
        this.showUnFocusedText();
    }
}
component.prototype.inputFocused = function()
{
    this.removeUnFocusedText();
}
component.prototype.inputAttributeSet = function()
{
    var curEvent = shell.currentEvent;
    if(curEvent.attributeName == "value")
    {
        var inputField = curEvent.targetBox;
        if(inputField.value == "")
        {
            if(!inputField.focused && !this._gadget.focused)
            {
                this.showUnFocusedText();
            }
        }
        else
        {
            this.removeUnFocusedText();
        }
    }
}
