function component(_gadget)
{
	this.mSMSObj;//object for the data 
	this.mElements;//object for the text 
}

function SMSObj(htmlElement,blockID,ResourcePath)
{
	this.htmlElement = htmlElement;//DOM where DIV should be created
	this.mBlockId = blockID;//ID of the created DIV
	this.mImgResPath = ResourcePath;// folder where images will be stored
}

component.prototype.Init = function(htmlElement,blockID,ResourcePath)
{
	this.mSMSObj = new SMSObj(htmlElement,blockID,ResourcePath);//object for the data 
	//htmlElement.className = 'd';
//	html_str  =	'<style type="text/css">@import url('+ResourcePath+'\SMS.css);</style>';
			html_str = '<div class="dSmsErr" id="DivShow_'+blockID+'">';	
			html_str  +='<div class="dSmsErr_1">';
				html_str  +='<div class="dSmsErr_1-1" id="userName_'+blockID+'">&nbsp;</div>';
				html_str  +='<div class="dSmsErr_1-2" id="userText_'+blockID+'"">&nbsp;</div>';
				html_str  +='<div class="dSmsErr_1-3" id="links_'+blockID+'">';
				html_str  +='<span id="actions_'+blockID+'"></span></div>';
			html_str  +='</div>';
				html_str  +='<div class="dSmsErr_2">';
					html_str  +='<div class="dSmsErr_2-1" id="Status_'+blockID+'">&nbsp;</div>';	
					html_str  +='<div class="dSmsErr_2-2" id="imageStatus_'+blockID+'">&nbsp;</div>';				
				html_str  +='</div>';		
		html_str  +='</div>';
			
		this.mElements = new Object();
		htmlElement.innerHTML = html_str;
		var htmlDoc = htmlElement.document;
		this.mElements['DivShow'] = htmlDoc.getElementById('DivShow_'+blockID);
		this.mElements['userName'] = htmlDoc.getElementById('userName_'+blockID);	
		this.mElements['userText'] = htmlDoc.getElementById('userText_'+blockID);
		this.mElements['links'] = htmlDoc.getElementById('links_'+blockID);
		this.mElements['imageStatus'] = htmlDoc.getElementById('imageStatus_'+blockID);
		this.mElements['Status'] = htmlDoc.getElementById('Status_'+blockID);
		this.mElements['actions'] = htmlDoc.getElementById('actions_'+blockID);
}

component.prototype.SetState = function(stateName,stateData)
{  
	this.mElements['userName'].innerHTML = stateData.Nickname ;//user name and time 
	this.mElements['userText'].innerHTML = stateData.SMSText.replace(/\n/ig,"<br>");//user sms text 

	switch(stateName)
	{
		case "Sending": 
			this.mElements['imageStatus'].innerHTML ='<img src="'+this.mSMSObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/SMS/sending.gif" border="0" width="16" height="16" />';
			this.mElements['Status'].innerHTML = stateData.StatusText;//text to display after icon
			break;
		case 'Failed':// Update status and make text red
			this.mElements['userName'].style.color='red';
			this.mElements['userText'].style.color='red';
			this.mElements['Status'].style.color='red';
			this.mElements['imageStatus'].innerHTML='<img src="'+this.mSMSObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/SMS/failed.gif" border="0" width="16" height="16" />';
			this.mElements['Status'].innerHTML = stateData.StatusText;
			break;
			
		case 'Success':// Update status and display carrier's URL
			this.mElements['imageStatus'].innerHTML='<img src="'+this.mSMSObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/SMS/done.gif" border="0" width="16" height="16" />';
			if (stateData.CarrierUrl == '')
			{
				if (stateData.CarrierName == '')
					this.mElements['Status'].innerHTML = "";
				else
					this.mElements['Status'].innerHTML = stateData.StatusText+stateData.CarrierName;
			}
			else
				this.mElements['Status'].innerHTML = stateData.StatusText+'<a class="dSmsErr_1-link" href="'+stateData.CarrierUrl+'">'+stateData.CarrierName+'</a>';
			break;
	}

	// actions
	var html_str = '';
	var lenght_Actions = stateData.Actions.Count;
	var Action;
	for(var i=0; i < lenght_Actions; i++)
	{
		Action = stateData.Actions.Item(i);
		html_str += '<a class="dSmsErr_1-link" href="'+Action.ActionURL+'">'+Action.ActionText+'</a>';
		if (Action.ActionShortcutText != '')
			html_str += '&nbsp;'+Action.ActionShortcutText+'';
		html_str += '&nbsp;&nbsp;';
	}
	this.mElements['actions'].innerHTML = html_str;
}

