
var glevel=''; // maor
	var bannerTimerHndl;
	var retryTimeout = null;
	var gHandshake = false; // have we already performed a hahdshake?
	var hsConnection = null;
	var gameSocketID = null;
	var gPlaying = false;
	var gameUrl;
	var gRoom; // last room searched
    var gBannerTimeout = 10000;
    var gBannerDisplayedEnoughTime = false;
    XtrazPreferences.init();
	var gGameName = XtrazPreferences.getPreference("Config", "GameName");
	var gGc='';
	if(gGameName == undefined)
	gGameName = 'unknown';
glevel=get_parameter("level");// maor
gGc=get_parameter("act");//maor

function make_rand_game(cmd, arg){
		var msg = cmd + ":" + arg;
		XtrazDebug.trace("FSCommand", cmd, arg);
		if (cmd == "closeWindow")
		{
				XtrazConnector.getIcqConnector().ClosePluginUISite ();
		}
		else {
	            bannerTimerHndl = setInterval("searchUsers('"+arg+"')",1000);
		}
}  	
function get_parameter( parameterName ) 
{
  var queryString = window.location.search.substring(1).toLowerCase();
  var parameters = new Array();
  parameters = queryString.split('&');
  for(var i = 0; i < parameters.length; i++) {
    if (parameters[i].indexOf(parameterName.toLowerCase())>=0) {
      var parameterValue = new Array();
      parameterValue = parameters[i].split('=');
      return parameterValue[1];
    }
  }
  return "null";
}        
 	function init()	{
		XtrazDebug.trace("lobby init");

		gameUrl = XtrazPreferences.getPreference("Config", "GameURL");
        gBannerTimeout = XtrazPreferences.getPreference("Config", "BannerTimeout") * 1000;
		XtrazDebug.assert(gameUrl, "Lobby onHandshakeResult: no game url in prefs");

		XtrazBroadcaster.addListener(this, XtrazSocket.msgConnectionDied, XtrazRandom.msgServerReady);
		XtrazSocket.setOwner(this);
		top.initBody(window.document,document.getElementById("theBanner"));
		var lobby = document.getElementById("lobby");
		lobby.focus();
	try{
		var icqConnector = XtrazConnector.getIcqConnector();
		var countryId = icqConnector.GetGeoTargetClientCountryCode();
	}
	catch(e){}
		
		var theBanner = document.getElementById("theBanner");
		var banner_iframe = document.getElementById("banner_iframe");
/*		if ( (countryId == 44) || (countryId == 45) ||  (countryId == 46) ||  (countryId == 47) || 
			 (countryId == 33) || (countryId == 34) || (countryId == 358) )
		{*/
			if(banner_iframe && banner_iframe.style.display != "none"){
				banner_iframe.src = "lobby_banner.html"
				setTimeout("setBannerDisplayedEnough()",gBannerTimeout)
			}
/*		}
		else
			theBanner.style.display = "none"*/
			
			if(gGc=="gc"){
				make_rand_game("send",glevel);	//maor		
			}
	}

	function listenToMessage(msg, p1, p2 /* more params */) {
		XtrazDebug.trace("lobby listentomessage", msg, p1, p2);
		switch (msg) {
			case XtrazRandom.msgServerReady:
				var found = false;
				if (p1 == gRoom) {
					found = tryNextUIN();		
				}
				else {
					XtrazDebug.trace("random server ready with wrong room, sent", p1, "lobby has", gRoom);
				}
				break;
			case XtrazSocket.msgConnectionDied:
				if (p1 == hsConnection) {
					var buddy = XtrazSocket.getSocketBuddy(p1);
					onHandshakeResult(false, buddy); 
				}
				break;
			case XtrazSocket.msgHandshake:
				if (gHandshake) {
					XtrazDebug.trace("lobby received handshake during game");
				}
				else {
					top.onHandshake(p1, p2);
				}
		}
	}

// called when the random server has received the result of the find users query 
// nUINs is the number of available UINs
	function onRandomServerReady(nUINs) {
		XtrazDebug.trace("lobby onRandomServerReady");
	}
	
	function tryNextUIN() {
		var ret = false;
		var uin = XtrazRandom.getRandomUIN();
		if (uin) {
			XtrazDebug.trace("testing next uin", uin);
			if (! hsConnection) {
				hsConnection = XtrazSocket.openConnection(this);
				XtrazSocket.setSocketRetries(hsConnection, 2);
			}
			if (! gameSocketID) {
				gameSocketID = XtrazSocket.openConnection(this);
				XtrazDebug.trace("lobby prefs loaded, random connection id", gameSocketID);
			}

			XtrazSocket.setSocketBuddy(hsConnection, uin);
			XtrazSocket.setSocketBuddy(gameSocketID, uin);
			XtrazSocket.setSocketType(gameSocketID, XtrazSocket.eServer);

			XtrazDebug.trace("tryNextUIN created connection", hsConnection);
// Send notification to the distant game (to launch the game)
			ret = XtrazSocket.attemptHandShake(hsConnection, 15, gameSocketID);
		}
		else {
			XtrazRandom.registerSelf();
		}
		return ret;
	}

// should never be called
	function onNotificationResult(cookie, sUserID,sData,eCode) {
		XtrazDebug.assert(false, "lobby onnotification result", cookie, sUserID, sData, eCode);
	}

// called by XtrazSocket when a handshake arrives
	function onHandshake(sBuddy, doc) {
		var ret = ! gPlaying;
		if (ret) {
			gPlaying = true;
			if (retryTimeout) {
				clearTimeout(retryTimeout);
				retryTimeout = null;
			}
			if (gameSocketID) {
				XtrazDebug.trace("lobby game handshake, closing current connection", gameSocketID);
				XtrazSocket.closeConnection(gameSocketID);
			}
			var cID = XMLUtils.getValueByNodeName(doc, "//ConnectionID", -1);
			var nextTrans = XMLUtils.getValueByNodeName(doc, "//nextTransID", -1);
			var seq = XMLUtils.getValueByNodeName(doc, "//SEQ", -1);
			XtrazDebug.assert(cID != -1, "lobby onHandshake: bad connection id", cID);
			XtrazDebug.assert(nextTrans != -1, "lobby onHandshake: bad next trans id", nextTrans);
			XtrazDebug.assert(seq != -1, "lobby onHandshake: bad sequence", seq);
			XtrazDebug.trace("lobby onHandshake found connection id", cID, typeof(cID));

			gameSocketID = XtrazSocket.openConnection(this, cID);
			XtrazSocket.setSocketType(gameSocketID, XtrazSocket.eServer);
			XtrazSocket.setSocketBuddy(gameSocketID, sBuddy);

			XtrazSocket.setConnectionNextTransID(gameSocketID, nextTrans);
			XtrazDebug.assert(gameSocketID, "lobby onHandshake: bad remote connection id");
			XtrazDebug.trace("lobby game handshake, ConnectionID", gameSocketID);
			var icqConnector = XtrazConnector.getIcqConnector();
			XtrazConnector.addBuddy(sBuddy);
			icqConnector.RegisterForEvents(sbSessionEvents, sBuddy);
			icqConnector.RegisterForEvents(sbBuddyEvents, sBuddy);
			XtrazRandom.unregisterSelf();
			var myUin=icqConnector.GetIMOwnerData("SCREEN_NAME");
			var bld=get_parameter("bld");
			var dst=get_parameter("dst");
			var port=get_parameter("port");
			var winid=get_parameter("id");
			
			
			var url = makeGameURL(seq,myUin,1,bld,dst,port,winid);
			XtrazDebug.trace("lobby switching to", url);
//			window.location.href = url;
            launchGame(url)
		}
		return ret;
	}
    
    function setBannerDisplayedEnough()
    {
        gBannerDisplayedEnoughTime = true;
    }
    
    function launchGame(url)
    {
        if (gBannerDisplayedEnoughTime)
            window.location.href = url;
    }

// handle a remote OK for the handshake
	function onHandshakeResult(bSuccess, buddy) {
		XtrazDebug.trace("onHandshakeResult", bSuccess)
		if (! bSuccess) {
			if (buddy)
				XtrazRandom.unregisterUser(buddy);
			try{
				retryTimeout = setTimeout(tryAgain,2500)
	//			win.tryAgin();
			}
			catch(e){
				XtrazDebug.trace("startHandShakeFailed Error", e)
			}
		}
		else {
			XtrazConnector.addBuddy(buddy);
			var icqConnector = XtrazConnector.getIcqConnector();
	
			icqConnector.RegisterForEvents(sbSessionEvents, buddy);
			icqConnector.RegisterForEvents(sbBuddyEvents, buddy);
			XtrazRandom.unregisterSelf();
			var gameUrl = XtrazPreferences.getPreference("Config", "GameURL");
			XtrazDebug.assert(gameUrl, "Lobby onHandshakeResult: no game url in prefs");
			XtrazSocket.closeConnection(hsConnection);
	
			var bld=get_parameter("bld");
			var dst=get_parameter("dst");
			var port=get_parameter("port");
			var winid=get_parameter("id");
			var url = makeGameURL(1,buddy,2,bld,dst,port,winid); // 1 is the inviting sequence number
			XtrazDebug.trace("lobby switching to", url);
      launchGame(url)
		}
	}
	
	function makeGameURL(seq,id,mode,bld,dst,port,winid) {
		var url = gameUrl;
		url = XtrazUtils.addParamToURL(url, "bld", bld);
		url = XtrazUtils.addParamToURL(url, "dst", dst);
		url = XtrazUtils.addParamToURL(url, "id", winid);
		url = XtrazUtils.addParamToURL(url, "invType","random");
		url = XtrazUtils.addParamToURL(url, "rndConId", id+"_5");
		url = XtrazUtils.addParamToURL(url, "mode", mode);
		url = XtrazUtils.addParamToURL(url, "port", port);
		
		url = XtrazUtils.addParamToURL(url, "ConnectionID", gameSocketID);
		url = XtrazUtils.addParamToURL(url, "seq", seq);
		
		return url;
	}
	

	function tryAgain()
	{
		XtrazDebug.trace("trying random server again");
		tryNextUIN()
	}
    
	function searchUsers(arg)
	{
			if (!gBannerDisplayedEnoughTime)
					return;
			clearInterval(bannerTimerHndl);
			gRoom = XtrazPreferences.getPreference("Random", "Rooms", arg);
			XtrazDebug.trace("found room", gRoom);
			XtrazRandom.findUsers(gRoom);
	}