var g_nToasterInterval = 30 * 1000; // 10 seconds - Due to old code, the client divides non message related toaster uptime by 3

function component (_gadget)
{	   
	this.gadget = _gadget;	
}

component.prototype.init = function(oIcqConnector, sTitle, sIconUrl)
{
    g_oIcqConnector = oIcqConnector;
    
    var command			= g_oIcqConnector.App.CommandManager.CreateCommand("ShowCustomToaster");
    command.Owner		= g_oIcqConnector.Owner;
    command.WaitTime	= g_nToasterInterval; // Close time in milli-seconds
    command.IconUrl		= sIconUrl;
    command.Title		= sTitle;
    command.Content		= this.gadget;
    command.Library		= "box://xtraz/icq/content/email_notifier_service/index.box";

    this.m_oCommand = command;
}

component.prototype.popNewMailToaster = function(sDisplayName, sMsgTitle, sMsgTime, sLinkText, oAction)
{
	this.m_oAction = oAction;
	
    var gadget = this.gadget;
    gadget.setAttribute("simpleMsg", "false");

    gadget.setAttribute("displayName", sDisplayName);
    gadget.setAttribute("msgTitle", sMsgTitle);
    gadget.setAttribute("timeStamp", sMsgTime);    
    
    gadget.setAttribute("linkText", sLinkText);
        
    this.m_oCommand.Execute();
}

component.prototype.popNewMailsToaster = function(sMsgBoddy, sLinkText, oAction)
{
	this.popNewEmailServiceToaster(sMsgBoddy, sLinkText, oAction); // same implementation
}

component.prototype.popNewEmailServiceToaster = function(sMsgBoddy, sLinkText, oAction)
{
	this.m_oAction = oAction;
	
	var gadget = this.gadget;
	gadget.setAttribute("simpleMsg",	"true");
	gadget.setAttribute("text",			sMsgBoddy);
	gadget.setAttribute("linkText",		sLinkText);
	
	this.m_oCommand.Execute();
}

component.prototype.OnLinkPressed = function()
{
	if ( this.m_oAction )
	{
		this.m_oAction.run();
	}

	this.gadget.scene.close();
}
