function init()
{
	var prefsArrLength = shell.prefsArr.length;
	
	for(index=0;index<prefsArrLength;index++)
	{
		var container = scene.getBoxById("mainWin");
		var feedBox = scene.createBox("mainFeed");
		feedBox.setAttribute("id",shell.prefsArr[index].id);
		feedBox.setAttribute("feedCheckbox",shell.prefsArr[index].selected);
		feedBox.setAttribute("feedName",shell.prefsArr[index].title);
		feedBox.setAttribute("feedDescText",shell.prefsArr[index].description);
		feedBox.setAttribute("feedIconSrc",shell.prefsArr[index].logo);
		container.addChild(feedBox);
	}
}

function savePrefs()
{
	var prefsArrLength = shell.prefsArr.length;
	
	for(index=0;index<prefsArrLength;index++)
	{
		var feed = scene.getBoxById(shell.prefsArr[index].id);
		shell.prefsArr[index].selected = feed.getAttribute("feedCheckbox");
	}
	
	shell.isDialogOpened = false;
	
	var scn =  shell.getSceneByName("main");
	var myBox = scn.getBoxesByTag("xtra_info_feed_max");
	var thebox = myBox.getValue(0);
	thebox.sendMessage("",null);
	scene.close();
}
