function component (_gadget)
{	
	this.uin = 0;
	
	this.gadget = _gadget;
	this.parent;
	this.icqConnector;
	
	this.srvId = "cRandomizerSrv";
	this.randomChatID = "random_chat";
	this.mClient = '';
	this.isRegistered = false;
	this.lastRegGoup = -1;
	this.mRoomID = -1;
	this.mRetries = 0;
	this.eNoRetry = 0, this.eRetryReg =1, this.eRetryUnreg = 2;
	this.mRetryType = this.eNoRetry;
	this.maxRetry = 2;
	this.chatIdentity = '';

	this.mPermGroup = -1; // the fixed chat group, when no1 else wants to be registered
	this.mCurrentGroup = -1; // the current registered chat group
	this.mSavedGroup = -1; // chat group saved when switching to n/a
	
}

component.prototype.OnInitXtra = function( conector )
{	
	this.icqConnector = conector;
	this.uin = this.icqConnector.GetIMOwnerData("SCREEN_NAME");
	this.icqConnector.RegisterForEvents (4,this.uin);
	this.icqConnector.AttachEvent("ShutDown",onShutDown);
	//this.icqConnector.AttachEvent("OnRemoteNotification",onRemoteNotification);
	this.icqConnector.AttachEvent("OnPluginNotification",onPluginNotification);
	this.icqConnector.AttachEvent("OnOwnerDisconnected",onOwnerDisconnected);
	this.icqConnector.AttachEvent("OnOwnerStatusChanged",onOwnerStatusChanged);
	onShutDown.owner = this;
	//onRemoteNotification.owner = this;
	onPluginNotification.owner = this;
	onOwnerDisconnected.owner = this;
	onOwnerStatusChanged.owner = this;
	onRandomRegistered.owner = this;
	//this.getPrefs();
}

/*
function onRemoteNotification(uin,notify)
{
  arguments.callee.owner.onRemoteNotification(uin,notify);
}
*/
function onShutDown(reason)
{
  arguments.callee.owner.onShutDown(reason);
}
function onPluginNotification(notify)
{
  arguments.callee.owner.onPluginNotification(notify);
}
function onOwnerDisconnected(reason)
{
  arguments.callee.owner.onOwnerDisconnected(reason);
}
function onOwnerStatusChanged(new_status)
{
  arguments.callee.owner.onOwnerStatusChanged(new_status);
}

function onRandomRegistered()
{
	arguments.callee.owner.onRandomRegistered();
}

component.prototype.onOwnerStatusChanged = function( new_status ) 
{
	switch ( new_status )
	{
		case 4:
			// in case the user is N/A he's unregister.
			if (this.mCurrentGroup > 0) {
				this.mSavedGroup = this.mCurrentGroup;
				this.unregister_user();
			}
			break;
		default:
			var group = this.mSavedGroup;
			this.mSavedGroup = -1;
			if (group <= 0) {
				//this.read_identity_from_registry();
				group = this.mPermGroup;
			}
			if(group > 0)
				this.register_user(group);
			break;
	}
}


component.prototype.onShutDown = function(reason)
{
	//this.savePrefs();
	this.mCurrentGroup = 0;
	this.icqConnector = null;
	this.gadget = null;
}
/*
component.prototype.onRemoteNotification = function( from, notify ) 
{
	if ( this.mCurrentGroup <= 0 || this.mPermGroup != this.mCurrentGroup) {return;}

	var xmlDoc = RandomUtils.getScratchDocument();
	xmlDoc.loadXML( notify );

	if ( xmlDoc.parseError.errorCode != 0 ) {
		return;
	}
	// Check if the notification was sent to this service
	var srv_id = RandomUtils.getNode(xmlDoc, "//srv/id", '');

	if( srv_id != this.srvId) {
		return;
	}
	var cmd = RandomUtils.getNode(xmlDoc, "//C", '');

	switch ( cmd ) {
		case "IdentityRequest" :
			// Send my identity response to random_chat xtraz
			var uXml = "<R><UID>" + from + "</UID></R>";
			var qXml = "<Q><PluginID>" + this.randomChatID + "</PluginID></Q>";

			var dataXml = "<MSG><C>IdentityResponse</C><D>" + escape(this.chatIdentity) + "</D></MSG>";
			return dataXml
			break;

		case "ChatInvite" :
			// extract the invitation data
			identity = RandomUtils.getNode(xmlDoc, "//D", '');
			var chRet = false;
			if (identity != '') {
				var qXml = "<Q><PluginID>random_chat</PluginID></Q>";
				var dataXml = "<MSG><C>ChatRequest</C><D>" + escape(identity) + "</D></MSG>";
				var ret = this.icqConnector.NotifyPlugin( qXml, dataXml );
	
				if ( ret.match(/<NR\/>/) ) {
					// push the invitation to the client
					//webmsg = "<webmsg><PriliURL>" + identity + "</PriliURL><sh>Yes</sh><PluginID>" + this.randomChatID + "</PluginID><width>450</width><height>450</height><url>" + identity + "</url><title>Notification</title></webmsg>";
					chRet = "ChatInviteOk";
					webmsg = "<webmsg><sh>no</sh><PluginID>" + this.randomChatID + "</PluginID><width>450</width><height>450</height><url>" + identity + "</url><title>Get Lucky in Chat</title></webmsg>";
					this.icqConnector.InsertAlert( webmsg );
				}
				// return ok got the invitation answer
			}
			return chRet;
	}
}
*/
component.prototype.onPluginNotification = function(notify) 
{
	
	var xmlDoc = RandomUtils.getScratchDocument();
	xmlDoc.loadXML( notify );
	if ( xmlDoc.parseError.errorCode != 0 )
		return;

	// Check if the notification was sent to this service
	var srv_id = RandomUtils.getNode(xmlDoc, "//srv/id", '');

	if( srv_id != this.srvId)
		return;

	var cmd = RandomUtils.getNode(xmlDoc, "//C", '');

	switch ( cmd ) {
		case "IsRegistered" :
			return (this.mCurrentGroup > 0);
		case "IdentityChanged" :
			var oldPerm = this.mPermGroup;
			//this.read_identity_from_registry();
			// if the user is currently registered to a chat group, unreg
			if ( (this.mPermGroup < 1) && (this.mCurrentGroup == oldPerm) )
				this.unregister_user();
			else // last request gets precedence
				this.register_user(this.mPermGroup);
			break;

		case "Register" :
//			this.isRegistered = false;
			var cmd = RandomUtils.getNode(xmlDoc, "//C", '');
			var group  = RandomUtils.getNode(xmlDoc, "//CHATGROUP", '');
			if (group != '')
				this.register_user(group);
			break;

		case "Unregister" :
			// read the identity from the registry
//			this.isRegistered = false
			//this.read_identity_from_registry();

			if ( this.mPermGroup < 1 ) // no permanent chat group, just unreg
				this.unregister_user();
			else
				this.register_user(this.mPermGroup); // re-reg to permanent group
			break;
		default:
			break;
	}
}

component.prototype.onOwnerDisconnected = function(reason)
{
	this.mSavedGroup = this.mCurrentGroup;
	this.mCurrentGroup = 0;
}
/*
component.prototype.read_identity_from_registry = function() 
{
	this.mPermGroup = -1
	prefs = "";*/
	/*if(!tragetingSrv.isTargeted(this.randomChatID)) {
		return;
	}*/
/*
	try
	{
		prefs = this.icqConnector.GetPrefsValues(false, this.randomChatID);
	} 
	catch ( e ) {return;}

	if ( ! prefs)
		return;
	var xml_doc = RandomUtils.getScratchDocument();
	xml_doc.loadXML(prefs);
	if ( xml_doc.parseError.errorCode != 0 ) {
		return; 
	}

	this.chatIdentity = xml_doc.xml;
	var available = RandomUtils.getNode(xml_doc, "//AVAIL", 0);
	if (available)
		this.mPermGroup = mRandomUtils.getNode(xml_doc, "//CHATGROUP", '');
}
*/


component.prototype.register_user = function(groupId) 
{
	if ((groupId > 0) && (groupId != this.mCurrentGroup)) 
	{
	// register the user on the randomizer server
		this.lastRegGoup = groupId
		var url = this.makeRegURL(groupId);
		this.mRetries = 0;
		RandomUtils.loadDocument(url, this, "onRandomRegistered", groupId);
	}
	else {}
}

component.prototype.unregister_user = function()
{
	if (this.mCurrentGroup > 0) 
	{
		var url = this.makeRegURL(0);
		this.mRetries = 0;
		RandomUtils.loadDocument(url, this, "onRandomRegistered", 0);
	} 
	else {}
}
component.prototype.onRandomRegistered = function(doc, cookie) 
{
	var success = '';
	if (doc.parseError.errorCode == 0 ) {
		success = RandomUtils.getNode(doc, "//RES", '');
	}
	if ( success == "SUCCESS" ) {
		this.mCurrentGroup = cookie;
	}
	else {
		if (this.mRetries < this.maxRetry) {
			this.mRetries++;
			var url = this.makeRegURL(cookie);
			RandomUtils.loadDocument(url, this, "OnRandomRegistered", cookie);
		}
	}
}

component.prototype.makeRegURL = function(groupId)
{
	var url = "http://xtraz.icq.com/random/register_user.php?group=" + groupId + "&uin=" + this.uin;
	return url;
}
/*
component.prototype.savePrefs = function(  ) 
{
	return;
	try {
		var doc = RandomUtils.getScratchDocument();
		var node = doc.createElement(this.srvId);
		doc.appendChild(node);
		var child = doc.createElement("chatGroup");
		node.appendChild(child);
		child.appendChild(doc.createTextNode(this.mPermGroup));
		//SavePreferences(null, "srvMng", this.srvId, doc.xml, null);
	}
	catch(e) {}
}
*/
/*
component.prototype.getPrefs = function(  ) 
{
	//var prefs = GetPreferences(null,"srvMng", this.srvId, null);
	var prefs = null;
	if (prefs) {
		var doc = RandomUtils.getScratchDocument();
		doc.loadXML(prefs);
		this.mPermGroup = RandomUtils.getNode(doc, "chatGroup", -1);
	}
	else {
		this.savePrefs();
	}
}
*/
function RandomUtils()
{
	this.gScratchDoc = null;
}

//var RandomUtils = { gScratchDoc : null };
RandomUtils.loadDocument = function(src, owner, callback, cookie) 
{
	var doc = 	new ActiveXObject("Msxml.DOMDocument");
	doc.async = true;
	if (doc) {
		var f = function() {
			var dis = arguments.callee;
			var doc = dis.doc;
			if (doc.readyState == 4) {
				doc.onreadystatechange = new Function();
				dis.owner[dis.callback](doc, dis.cookie);
				delete dis.docl;
				delete dis.owner;
				delete dis.callback;
			}
		}
		f.doc = doc;
		f.owner = owner;
		f.callback = callback;
		f.cookie = cookie;
		doc.onreadystatechange = f;
		doc.load(src);
	}
	else {}
	return doc;
}

RandomUtils.getNode = function(xml, nodeName, defValue) {
	var ret = defValue;
	try {
		var node = xml.selectSingleNode(nodeName);
		if (node) {
			if (node.nodeType == 1) {
				var child1 = node.firstChild;
				if (child1) {
					if (child1.nodeType == 3) {
						ret = RandomUtils.valudOf(child1.nodeValue);
					}
					else
						ret = child1;
				}
			}
			else if (node.nodeType == 3) {
				ret = RandomUtils.valudOf(node.nodeValue);
			}
		}
	}
	catch (e) {}
	return ret;
}

RandomUtils.valudOf = function(sValue) {
	var ret = sValue;
	var t = typeof(sValue);
	switch (t) {
		default:
			ret = String(sValue);
			break;
		case 'number':
			break; // nothing to do
		case "string":
			var nValue = parseInt(sValue);
			if (String(nValue) == sValue) {
				ret = nValue;
			}
			else {
				var lvalue = sValue.toLowerCase();
				switch (lvalue) {
					case 'false':
						ret = false;
						break;
					case 'true':
						ret = true;
						break;
					case 'null':
						ret = null;
						break;
				}
			}
			break;
		}
	return ret;
}

RandomUtils.getScratchDocument = function() {
	if (! this.gScratchDoc) {
		this.gScratchDoc = new ActiveXObject("Msxml.DOMDocument");
		this.gScratchDoc.async = false;
	}
	else {
		if (this.gScratchDoc.documentElement)
			this.gScratchDoc.removeChild(this.gScratchDoc.documentElement);
	}
	return this.gScratchDoc;
}
