//****************************************************************************
//
//     File Name:   aolInput.js
//
//****************************************************************************
//   C O P Y R I G H T   A N D   C O N F I D E N T I A L I T Y   N O T I C E
//****************************************************************************
//
//      Copyright (c) 2004-2006 America Online, Inc.  All rights reserved.
//      This software contains valuable confidential and proprietary
//      information of America Online, Inc. and is subject to applicable
//      licensing agreements.  Unauthorized reproduction, transmission or
//      distribution of this file and its contents is a violation of
//      applicable laws.
//
//            A M E R I C A   O N L I N E   C O N F I D E N T I A L
//
//****************************************************************************
function component (_gadget)
{
    this.scriptLoaded = false;
}

//****************************************************************************
component.prototype.onContextMenu = function()
{
    if (!this.scriptLoaded)
        this.scriptLoaded = this._gadget.importScript("box://boxelyToolkit/content/core/inputContext.js", "jscript");

    var inputContext = this._gadget.scene.getBoxById("_inputContext");
    if (inputContext == null)
        this.initContentMenu();
    else
        this.setUpdateValues(inputContext);
}

component.prototype.onCheckCapsLockOn = function()
{
    var capsLockOn = appUtils.capsLockState;
    this._gadget.setAttribute("capsLockOn", (capsLockOn) ? "true" : "false");
    if (capsLockOn && this._gadget.getAttribute("useDefaultWarningStyle") == "true")
    {
        this._gadget.removeAttribute("defaultCapsLockOnStyle");
        this._gadget.setAttribute("defaultCapsLockOnStyle", "true");
    }
}

component.prototype.onPasswordInputFocus = function()
{
    this._gadget.setSelection(0, -1);
    this._gadget.onCheckCapsLockOn();
}

