var undefined;

var DOMUtils = new Object;

DOMUtils.getObject = function(obj) {
	if (typeof(obj) == "string")
		obj = document.getElementById(obj);
	if (undefined == obj)
		obj = null;
	return obj;
}

DOMUtils.getElementById = function(obj, sID) {
	return document.getElementById(sID);

	obj = DOMUtils.getObject(obj);
	if (XtrazUtils.isEmpty(obj) || XtrazUtils.isEmpty(sID))
		return null;

	var f = obj['getElementById'];
	var ret = null;
	if (typeof(f) == "undefined") {
		try {
			var child = obj.firstChild;
			var theID;
			while (child && (! ret)) {
				theID = DOMUtils.getObjectId(child);
				if (theID == sID) {
					ret = child;
				}
				else {
					ret = DOMUtils.getElementById(child, sID);
				}
				child = child.nextSibling;
			}
		}
		catch(e) {
			XtrazDebug.logException("getelementById", e);
		}
	}
	else {
		ret = obj.getElementById(sID);
	}
	return ret;
}

DOMUtils.getObjectClass = function(obj) {
	if (XtrazUtils.browser.isIE)
		theClass = obj.className;
	else {
		theClass = obj.getAttribute("class");
	}
	if (XtrazUtils.isEmpty(theClass))
		theClass = '';
	return theClass;
}

DOMUtils.createElement = function(sType, sID, sClass) {
	var ret = document.createElement(sType);
	if (XtrazUtils.isNonEmpty(sID)) {
		ret.id = sID;
		ret.setAttribute("id", sID);
	}
	if (XtrazUtils.isNonEmpty(sClass))
		DOMUtils.setObjectClass(ret, sClass);
	return ret;
}

DOMUtils.setObjectClass = function(obj, theClass) {
	obj = DOMUtils.getObject(obj);
	if (obj) {
		obj.className = theClass;
		if (! XtrazUtils.browser.isIE) {
			obj.setAttribute("class", theClass);
		}
	}
}

DOMUtils.hasAttribute = function(obj, attr) {
	var ret = false;
	obj = DOMUtils.getObject(obj);
	if (obj) {
		try {
			var atr = obj.getAttribute(attr);
			XtrazDebug.trace("hasattribute: typeof", attr, "is",typeof(atr));
			ret = (typeof(attr) != "undefined");
		}
		catch (e) {
		
		}
	}
	return ret;
}

DOMUtils.getObjectId = function(obj) {
	var ret = '';
	try {
		ret = obj.id;
		if (XtrazUtils.isEmpty(ret)) {
			ret = obj.getAttribute('id');
		}
	}
	catch (e) {
	
	}
	return ret;
}

DOMUtils.removeNode = function(node) {
	try {
		var p = node.parentNode;
		p.removeChild(node);
	}
	catch (e) {
		XtrazDebug.trace("removeNode exception",e);	
	}
}

// $$ test
DOMUtils.getElementsByTagName = function(obj, sID, bDeep) {
	var ret = new Array();
	obj = DOMUtils.getObject(obj);
	if (XtrazUtils.isEmpty(obj) || XtrazUtils.isEmpty(sID))
		return ret;
	if (arguments.length < 3)
		bDeep = true;
	
	sID = String(sID);
	sID = sID.toLowerCase();

	var f = obj['getElementsByTagName'];
	if ((! bDeep) || (typeof(f) == "undefined")) {
		try {
			var nextDiv = obj.firstChild;
			while(nextDiv) {
				var tagName = nextDiv.tagName;
				if (XtrazUtils.isNonEmpty(tagName)) {
					if (tagName.toLowerCase() == sID) {
						ret.push(nextDiv);
					}
					if (bDeep) {
						var tmp = DOMUtils.getElementsByTagName(nextDiv, sID, bDeep);
						ret = ret.concat(tmp);
//						XtrazDebug.trace("recursed gebtn returned" , tmp.length, "after concat have",ret.length);
					}
				}
				nextDiv = nextDiv.nextSibling;
			}
		}
		catch (e) {
			XtrazDebug.trace("getElementsBytagName exception", e);
		}
	}
	else {
		ret = obj.getElementsByTagName(sID);
	}
	return ret;
}


