/**
 * parentDragger's constructor.
 *
 * @param  _gadget the gadget
 */
function component (_gadget) 
{ 
	this.gadget = _gadget; 
	
}

component.prototype.onDragStart = function ()
{
	var eventObj = shell.getCurrentEvent();
	if (eventObj)
	{
		var offsetX;

		if (shell.zlangoGlobals.rtl)
			offsetX = this.gadget.boxX - eventObj.boxX; // The offset of the click in this gadget's parent's box.
		else
			offsetX = this.gadget.boxX + eventObj.boxX; // The offset of the click in this gadget's parent's box.

		var offsetY = this.gadget.boxY + eventObj.boxY; // The offset of the click in this gadget's parent's box.
		this.gadget.parent.onDragStart(offsetX, offsetY);
  	}
}



component.prototype.onDrag = function ()
{
    var eventObj = shell.getCurrentEvent();
    if (eventObj)
    {
		this.gadget.parent.onDrag(eventObj);
	}
}

component.prototype.onDragEnd = function ()
{
	this.gadget.parent.onDragEnd();
}

